(************************************************************************)
(* cxt.sml                                                              *)
(*                                                                      *)
(* Description:                                                         *)
(*    Contexts                                                          *)
(*                                                                      *)
(* Author:                                                              *)
(*    Evan Chang                                                        *)
(************************************************************************)

(* $Id: cxt.sml,v 1.3 2002/04/24 02:12:13 bechang_conductor Exp $ *) 


structure Cxt :> CXT =
struct

  datatype 'a Cxt = 
      Empty
    | Ext of 'a Cxt * 'a

  fun length (Empty) = 0
    | length (Ext (G, A)) = 1 + length (G)

  fun add (G, x) = Ext(G, x)

  fun combine (G, G') =
      let
        fun combine' (Empty, a) = a
          | combine' (Ext (Gs,x), a) = combine' (Gs, Ext (a,x))
      in
        combine' (G', G)
      end

end; (* structure Cxt *)
