(************************************************************************)
(* hashable-sig.sml                                                     *)
(*                                                                      *)
(* Description:                                                         *)
(*    An interface for hashable keys.                                   *)
(*                                                                      *)
(* Author:                                                              *)
(*    Evan Chang                                                        *)
(************************************************************************)

(* $Id: *)

signature HASHABLE =
sig

  (* The hashable key *)
  type key

  (* The type of the hash *)
  type hash

  (* Hash function on key *)
  val hash : key -> hash

  (* Equality predicate on key *)
  val eq : key * key -> bool

  (* Convert a hash into an int for indexing *)
  val index : hash -> int

end; (* signature HASHABLE *)
