(************************************************************************)
(* llprover-sig.sml                                                     *)
(*                                                                      *)
(* Description:                                                         *)
(*     A simple interface for a theorem prover for linear logic.        *)
(*                                                                      *)
(* Author:                                                              *)
(*     Evan Chang                                                       *)
(************************************************************************)

(* $Id: llprover-sig.sml,v 1.2 2002/04/24 02:12:13 bechang_conductor Exp $ *)



(************************************************************************)
(* signature LLPROVER                                                   *)
(*                                                                      *)
(*   Interface:                                                         *)
(*                                                                      *)
(*     This signature gives a simple interface for a theorem prover     *)
(*     for linear logic.                                                *)
(*                                                                      *)
(************************************************************************)
signature LLPROVER =
sig

  structure Prop : PROP
  structure Cxt  : CXT

  (* prove (G,D,C) = b

     G (Gamma) is the context containing the unrestricted hypotheses
     D (Delta) is the context containing the linear hypotheses
     C is the goal

     Returns:
       true if  G; D |- C

     *TODO Need to extend to return proof term*
  *)
  val prove : Prop.prop Cxt.Cxt * Prop.prop Cxt.Cxt * Prop.prop -> bool

end; (* signature LLPROVER *)
