(************************************************************************)
(* prop-sig.sml                                                         *)
(*                                                                      *)
(* Description:                                                         *)
(*     Abstract syntax of linear logic propositons.                     *)
(*                                                                      *)
(* Author:                                                              *)
(*     Evan Chang                                                       *)
(************************************************************************)

(* $Id: prop-sig.sml,v 1.1 2002/04/24 02:12:13 bechang_conductor Exp $ *)


signature PROP =
sig

  datatype prop =                       (* A ::=         *)
    Atom of string                      (*       P       *)
  | Tensor of prop * prop               (*     | A (x) B *)
  | Lolli of prop * prop                (*     | A -o B  *)
  | Unit                                (*     | 1       *)
  | With of prop * prop                 (*     | A & B   *)
  | Or of prop * prop                   (*     | A (+) B *)
  | Zero                                (*     | 0       *)
  | Top                                 (*     | T       *)
  | Implies of prop * prop              (*     | A => B  *)
  | Bang of prop                        (*     | !A      *)

  val eq : prop * prop -> bool
  val toString : prop -> string

end; (* signature PROP *)
