(************************************************************************)
(* uniqueid-sig.sml                                                     *)
(*                                                                      *)
(* Description:                                                         *)
(*    An interface for a unique ID source.                              *)
(*                                                                      *)
(* Author:                                                              *)
(*    Evan Chang                                                        *)
(************************************************************************)

(* $Id: *)


(**************************************************************)
(* signature UNIQUEIDSRC                                      *)
(*                                                            *)
(* Create a unique id source.                                 *)
(**************************************************************)
signature UNIQUEIDSRC =
sig

  type id
  type idsource = unit -> id

  (******************************************)
  (* Create a new source.                   *)
  (******************************************)
  val new : unit -> idsource

end; (* signature UNIQUEIDSRC *)



(**************************************************************)
(* signature UNIQUEID                                         *)
(*                                                            *)
(* Define some type that can be an ID.                        *)
(**************************************************************)
signature UNIQUEID =
sig

  type id
  
  (******************************************)
  (* Initial ID                             *)
  (******************************************)
  val initial : id

  (******************************************)
  (* Next                                   *)
  (******************************************)
  val next : id -> id

end; (* signature UNIQUEID *)
