(************************************************************************)
(* uniqueidsrc.sml                                                      *)
(*                                                                      *)
(* Description:                                                         *)
(*    An implementation for a unique ID source.                         *)
(*                                                                      *)
(* Author:                                                              *)
(*    Evan Chang                                                        *)
(************************************************************************)

(* $Id: *)


(**************************************************************)
(* functor UniqueIdSrc                                        *)
(*                                                            *)
(* Create a unique id source.                                 *)
(**************************************************************)
functor UniqueIdSrc(I : UNIQUEID) :> UNIQUEIDSRC where type id = I.id =
struct

  type id = I.id
  type idsource = unit -> id

  (******************************************)
  (* Create a new source.                   *)
  (******************************************)
  fun new () =
      let
        val id = ref (I.initial)
		 
        fun source () =
            let
              val r = !id
	      val _ = id := I.next r
	    in
	      r
	    end
      in
        source
      end

end; (* functor UniqueIdSrc *)
